<?php

use Silex\Application;
use Silex\Provider\AssetServiceProvider;
use Silex\Provider\MonologServiceProvider;
use Silex\Provider\TwigServiceProvider;
use Silex\Provider\ServiceControllerServiceProvider;
use Silex\Provider\HttpFragmentServiceProvider;
use Symfony\Component\HttpFoundation\Request;

$app = new Application();
$app->register(new MonologServiceProvider());
$app->register(new ServiceControllerServiceProvider());
$app->register(new AssetServiceProvider());
$app->register(new TwigServiceProvider());
$app->register(new HttpFragmentServiceProvider());
$app['twig'] = $app->extend('twig', function ($twig, $app) {
  // add custom globals, filters, tags, ...
  return $twig;
});

// Support PATCH/PUT/DELETE.. emulation on POST for browsers. Beware XSS.
Request::enableHttpMethodParameterOverride();

$app['model'] = function (Application $app) {
  return new Model($app['data']);
};

return $app;
